//
// $Id:$
// Copyright (C) 2004 Tadamasa Teranishi All rights reserved.
//     This is free software with ABSOLUTELY NO WARRANTY.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either versions 2, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA
//

try
{
    var obj = new ActiveXObject("Word.Application")
}
catch(e)
{
    WScript.Echo("You need Microsoft Office Word. Please install and try again.\n");
    WScript.Quit(1);
}

try
{
    var conv
    obj.Visible = false
    obj.DisplayAlerts = false

    var version = obj.Version
    print("Microsoft Word " + version)

    conv = obj.FileConverters

    var class_array = new Array
    var name_array = new Array
    var ext_array = new Array
    var canopen_array = new Array
    var cansave_array = new Array

    for (i = 0; i < conv.Count; i++) {
        var converter = conv.Item(i + 1)

        class_array[i] = (converter.ClassName).toLowerCase()
        name_array[i] = (converter.Name).toLowerCase()
        ext_array[i] = (converter.Extensions).toLowerCase()
        canopen_array[i] = converter.CanOpen
        cansave_array[i] = converter.CanSave
    }

    for (i = 0; i < conv.Count - 1; i++) {
        for (j = i + 1; j < conv.Count; j++) {
            if (class_array[i] > class_array[j]) {
                var tmp

                tmp = class_array[i]
                class_array[i] = class_array[j]
                class_array[j] = tmp

                tmp = name_array[i]
                name_array[i] = name_array[j]
                name_array[j] = tmp

                tmp = ext_array[i]
                ext_array[i] = ext_array[j]
                ext_array[j] = tmp

                tmp = canopen_array[i]
                canopen_array[i] = canopen_array[j]
                canopen_array[j] = tmp

                tmp = cansave_array[i]
                cansave_array[i] = cansave_array[j]
                cansave_array[j] = tmp
            }
        }
    }

    for (i = 0; i < conv.Count; i++) {
        var inst = "-"
        var read = "-"
        var write = "-"

        if (name_array[i] != "") {
            inst = " "
        } 
        if (canopen_array[i] == 1) {
            read = "r"
        }
        if (cansave_array[i] == 1) {
            write = "w"
        }

        print(inst + read + write + " " + class_array[i] + ":" + ext_array[i])
    }

    obj.Quit();
}
catch(e)
{
    print("Error:")
    print(e.number + ": " + e.description)
    WScript.Quit(2)
}

function print(s)
{
    WScript.Echo(s)
}
